#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <sql.h>
#include <sqlext.h>

#define MAXBUFLEN 255

	
char	rgbValue[MAXBUFLEN] = "";
SDWORD	pcbValue = 0;
FILE	*logfile = 0L;
HENV	henv = SQL_NULL_HENV;
HDBC	hdbc = SQL_NULL_HDBC;     
HSTMT	hstmt = SQL_NULL_HSTMT;
char	logstring[MAXBUFLEN] = "";
void	ProcessLogMessages(char *);

void main()
{

	RETCODE retcode;

	UCHAR	szConnectString[] = "DSN=henryl_nt;UID=sa;PWD=;",
			szConnectStringOut[MAXBUFLEN+1] = "";
		
	SWORD	szConnectStringOutLen;

	logfile = fopen("testodbc.log","w+");
		
 	// Allocate the ODBC Environment and save handle.
	retcode = SQLAllocEnv (&henv);
	if( (retcode != SQL_SUCCESS_WITH_INFO) &&  (retcode != SQL_SUCCESS))
	{
		fprintf(logfile,"SQLAllocEnv() Failed\n");
		return;		
	}

	// Allocate the ODBC Connection and save handle.
	retcode = SQLAllocConnect(henv, &hdbc);
	if( (retcode != SQL_SUCCESS_WITH_INFO) &&  (retcode != SQL_SUCCESS))
	{
		fprintf(logfile,"SQLAllocConnect() Failed\n");
		return;
	}		


	retcode = SQLDriverConnect(hdbc,(HWND)0,szConnectString
		,(SWORD)strlen((const char *)szConnectString),
		szConnectStringOut,MAXBUFLEN, &szConnectStringOutLen,
		SQL_DRIVER_NOPROMPT);

	if ( (retcode != SQL_SUCCESS) && (retcode != SQL_SUCCESS_WITH_INFO) )
	{
	   	ProcessLogMessages("SQLDriverConnect() Failed\n");
	   	return;
	}
	else
		{
			ProcessLogMessages("Connect Successful\n");
			fprintf(logfile,"\nDriver revised connection string = %s\n\n",
				szConnectStringOut);
		}


// start code


retcode = SQLAllocStmt(hdbc, &hstmt);
//retcode = SQLSetStmtOption(hstmt, SQL_QUERY_TIMEOUT, 60);

retcode = SQLExecDirect(hstmt, (UCHAR *)"select * from test01", SQL_NTS);
if ( (retcode != SQL_SUCCESS) && (retcode != SQL_SUCCESS_WITH_INFO)  )
	   ProcessLogMessages("select * from model01 - execdirect failed");
                  

retcode = SQL_SUCCESS; 

retcode = SQLFetch(hstmt);
if ( (retcode != SQL_SUCCESS) && (retcode != SQL_SUCCESS_WITH_INFO)  ) {
		ProcessLogMessages("First Fetch had problems");
	   	goto exit1;
	   	}


while( retcode != SQL_NO_DATA_FOUND ) {
	retcode = SQLGetData(hstmt,1,SQL_C_CHAR,rgbValue,MAXBUFLEN,&pcbValue); 
	if ( (retcode != SQL_SUCCESS) && (retcode != SQL_SUCCESS_WITH_INFO)  ) {
			ProcessLogMessages("Problems on SQLGetData");
	   		goto exit1;
	   	} else {  
	   		fprintf(logfile,"The data value of column 1 is = %s\n",
				rgbValue);
	   	}


	retcode = SQLFetch(hstmt);
	if ( (retcode != SQL_SUCCESS) && (retcode != SQL_SUCCESS_WITH_INFO)  ) {
		ProcessLogMessages("Problems on a SQLFetch");
	   	goto exit1;
	}     
}

retcode = SQLFreeStmt(hstmt, SQL_CLOSE);   
retcode = SQLFreeStmt(hstmt, SQL_DROP);


exit1:	

	/* clean up */
	SQLDisconnect(hdbc);
	SQLFreeConnect (hdbc);
	SQLFreeEnv(henv);
	fclose(logfile);
}

void ProcessLogMessages(char *	logstring)
{
	RETCODE	plm_retcode = SQL_SUCCESS;
	UCHAR	plm_szSqlState[MAXBUFLEN] = "",plm_szErrorMsg[MAXBUFLEN] = "";
	SDWORD	plm_pfNativeError = 0L;
	SWORD	plm_pcbErrorMsg = 0;

	fprintf(logfile,logstring);	

	while (plm_retcode != SQL_NO_DATA_FOUND) {
		plm_retcode = SQLError(henv,hdbc,hstmt,plm_szSqlState,
			&plm_pfNativeError,plm_szErrorMsg,MAXBUFLEN - 1,
			&plm_pcbErrorMsg);
		if (plm_retcode != SQL_NO_DATA_FOUND){
			fprintf(logfile,"szSqlState = %s\n",plm_szSqlState);
			fprintf(logfile,"pfNativeError = %d\n",plm_pfNativeError);
			fprintf(logfile,"szErrorMsg = %s\n",plm_szErrorMsg);
			fprintf(logfile,"pcbErrorMsg = %d\n",plm_pcbErrorMsg);
		}
	} /* end while */
}